/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Arbres binaires, avec des valeurs de type int

// la structure est volontairement exportée
// l'arbre vide est représenté par NULL

#include "prelude.h"

#ifndef BINTREE
#define BINTREE

typedef struct Node {
  struct Node *left;
  int value;
  struct Node *right;
} bintree;

bintree *bintree_create(bintree *l, int v, bintree *r);

int bintree_size(bintree *t);
int bintree_height(bintree *t);

bintree *bintree_perfect(int h);
bintree *bintree_left(int h);

void bintree_preorder(bintree *t);
void bintree_inorder(bintree *t);
void bintree_postorder(bintree *t);

bintree *bintree_random(int n);

void bintree_write(bintree *t, FILE *f);
bintree *bintree_read(FILE *f);

void bintree_delete(bintree *t);

#endif
